Bug 436234 - gcc emits 100% useless packed warning
gcc emits 100% useless packed warning
Status: CLOSED WONTFIX
Product: Fedora
Classification: Fedora
Component: gcc (Show other bugs)
10
All Linux
low Severity high
: ---
: ---
Assigned To: Jakub Jelinek
Fedora Extras Quality Assurance
: Reopened, Triaged
Depends On:
Blocks:
  Show dependency treegraph
 
Reported: 2008-03-05 19:42 EST by JW
Modified: 2009-12-18 01:04 EST (History)
1 user (show)

See Also:
Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2009-12-18 01:04:46 EST
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---


Attachments (Terms of Use)

  None (edit)
Description JW 2008-03-05 19:42:23 EST
Description of problem:
gcc emits useless messages like "warning: 'packed' attribute ignored for field
of type 'char[62]'" which unnecessarily clutters output with totally useless
information.

Version-Release number of selected component (if applicable):
gcc-4.1.2-33

How reproducible:
Always

Steps to Reproduce:
1. create file x.c containing:
struct one
{
    short       a __attribute__ ((packed));
    char        b __attribute__ ((packed));
} __attribute__ ((packed));

2. gcc -c x.c

  
Actual results:
2. x.c:4: warning: 'packed' attribute ignored for field of type 'char'

Expected results:
No warning is necessary

Additional info:
Quite simply packing a 1 char into 1 char is a successful packing!
So why warn about it?  What is the point?
Should everyone have to edit their files and removed packed attribute if the
data type is char or if there is nothing to save in packing?  And what about
when the data type changes?  Do we really have to get our calculators out and
work out what the compiler may or may not be saving and add/remove packed
attributes accordingly?  And even if that is done, what is the net effect - just
the disappearance of the annoying compiler warnings?  gcc should be getting
smarter, not dumber.
Comment 1 Jakub Jelinek 2008-03-11 05:13:42 EDT
The warning is not useless.  Using packed attribute for char doesn't make any
sense.  Why are you doing that?
Comment 2 JW 2008-03-11 05:56:25 EDT
(In reply to comment #1)
> The warning is not useless.  Using packed attribute for char doesn't make any
> sense.  Why are you doing that?

It is useless.  What does it achieve?  Please explain.

BTW fixing bugs doesn't make any sense either.  Why are you doing that?

And please explain why packing with no saving is a failure which merits a warning.
Comment 3 Prarit Bhargava 2008-03-12 09:27:21 EDT
*** Bug 250313 has been marked as a duplicate of this bug. ***
Comment 4 JW 2008-03-21 00:43:05 EDT
(In reply to comment #1)
> The warning is not useless.

Maybe to be consistent gcc should emit a warning when one uses the -O flag and
no optimization is performed on a section of code?

Or maybe gcc should emit a warning when one uses "#if 0" along the lines of
"Conditional value is always false".

Please explain why the warning is not useless.  If one removed that packing from
something which doesn't get packed then what difference does that make?  It wont
change the code, it will only make the warning go away.  Therefore the warning
is useless.
Comment 5 Denys Vlasenko 2008-07-21 10:43:45 EDT
The type can be a typedef. It's not trivial to test whether this particular
typedef'ed type is "packable" or not. (I just tested - gcc 4.3.0 gives this
warning on typedefs too).
Comment 6 Bug Zapper 2008-11-26 05:02:09 EST
This message is a reminder that Fedora 8 is nearing its end of life.
Approximately 30 (thirty) days from now Fedora will stop maintaining
and issuing updates for Fedora 8.  It is Fedora's policy to close all
bug reports from releases that are no longer maintained.  At that time
this bug will be closed as WONTFIX if it remains open with a Fedora 
'version' of '8'.

Package Maintainer: If you wish for this bug to remain open because you
plan to fix it in a currently maintained version, simply change the 'version' 
to a later Fedora version prior to Fedora 8's end of life.

Bug Reporter: Thank you for reporting this issue and we are sorry that 
we may not be able to fix it before Fedora 8 is end of life.  If you 
would still like to see this bug fixed and are able to reproduce it 
against a later version of Fedora please change the 'version' of this 
bug to the applicable version.  If you are unable to change the version, 
please add a comment here and someone will do it for you.

Although we aim to fix as many bugs as possible during every release's 
lifetime, sometimes those efforts are overtaken by events.  Often a 
more recent Fedora release includes newer upstream software that fixes 
bugs or makes them obsolete.

The process we are following is described here: 
http://fedoraproject.org/wiki/BugZappers/HouseKeeping
Comment 7 Bug Zapper 2009-11-18 04:33:36 EST
This message is a reminder that Fedora 10 is nearing its end of life.
Approximately 30 (thirty) days from now Fedora will stop maintaining
and issuing updates for Fedora 10.  It is Fedora's policy to close all
bug reports from releases that are no longer maintained.  At that time
this bug will be closed as WONTFIX if it remains open with a Fedora 
'version' of '10'.

Package Maintainer: If you wish for this bug to remain open because you
plan to fix it in a currently maintained version, simply change the 'version' 
to a later Fedora version prior to Fedora 10's end of life.

Bug Reporter: Thank you for reporting this issue and we are sorry that 
we may not be able to fix it before Fedora 10 is end of life.  If you 
would still like to see this bug fixed and are able to reproduce it 
against a later version of Fedora please change the 'version' of this 
bug to the applicable version.  If you are unable to change the version, 
please add a comment here and someone will do it for you.

Although we aim to fix as many bugs as possible during every release's 
lifetime, sometimes those efforts are overtaken by events.  Often a 
more recent Fedora release includes newer upstream software that fixes 
bugs or makes them obsolete.

The process we are following is described here: 
http://fedoraproject.org/wiki/BugZappers/HouseKeeping
Comment 8 Bug Zapper 2009-12-18 01:04:46 EST
Fedora 10 changed to end-of-life (EOL) status on 2009-12-17. Fedora 10 is 
no longer maintained, which means that it will not receive any further 
security or bug fix updates. As a result we are closing this bug.

If you can reproduce this bug against a currently maintained version of 
Fedora please feel free to reopen this bug against that version.

Thank you for reporting this bug and we are sorry it could not be fixed.

Note You need to log in before you can comment on or make changes to this bug.